package com.ruoyi.ss.clean.service.impl;

import java.util.List;

import com.ruoyi.ss.clean.domain.Clean;
import com.ruoyi.ss.clean.domain.CleanQuery;
import com.ruoyi.ss.clean.domain.CleanVO;
import com.ruoyi.ss.clean.service.ICleanService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.ss.clean.mapper.CleanMapper;

/**
 * 保洁记录Service业务层处理
 *
 * @author qzz
 * @date 2024-11-19
 */
@Service
public class CleanServiceImpl implements ICleanService
{
    @Autowired
    private CleanMapper eCleanMapper;

    /**
     * 查询保洁记录
     *
     * @param cleanId 保洁记录主键
     * @return 保洁记录
     */
    @Override
    public CleanVO selectECleanByCleanId(Long cleanId)
    {
        return eCleanMapper.selectECleanByCleanId(cleanId);
    }

    /**
     * 查询保洁记录列表
     *
     * @param eClean 保洁记录
     * @return 保洁记录
     */
    @Override
    public List<CleanVO> selectECleanList(CleanQuery eClean)
    {
        return eCleanMapper.selectECleanList(eClean);
    }

    /**
     * 新增保洁记录
     *
     * @param eClean 保洁记录
     * @return 结果
     */
    @Override
    public int insertEClean(Clean eClean)
    {
        return eCleanMapper.insertEClean(eClean);
    }

    /**
     * 修改保洁记录
     *
     * @param eClean 保洁记录
     * @return 结果
     */
    @Override
    public int updateEClean(Clean eClean)
    {
        return eCleanMapper.updateEClean(eClean);
    }

    /**
     * 批量删除保洁记录
     *
     * @param cleanIds 需要删除的保洁记录主键
     * @return 结果
     */
    @Override
    public int deleteECleanByCleanIds(Long[] cleanIds)
    {
        return eCleanMapper.deleteECleanByCleanIds(cleanIds);
    }

    /**
     * 删除保洁记录信息
     *
     * @param cleanId 保洁记录主键
     * @return 结果
     */
    @Override
    public int deleteECleanByCleanId(Long cleanId)
    {
        return eCleanMapper.deleteECleanByCleanId(cleanId);
    }
}
