package com.ruoyi.ss.store.mapper;

import java.util.List;

import com.ruoyi.ss.store.domain.Store;
import com.ruoyi.ss.store.domain.StoreQuery;
import com.ruoyi.ss.store.domain.StoreVO;
import org.apache.ibatis.annotations.Param;

/**
 * 店铺Mapper接口
 *
 * @author qzz
 * @date 2024-11-20
 */
public interface StoreMapper
{
    /**
     * 查询店铺
     *
     * @param storeId 店铺主键
     * @return 店铺
     */
    public StoreVO selectEStoreByStoreId(Long storeId);

    /**
     * 查询店铺列表
     *
     * @param query 店铺
     * @return 店铺集合
     */
    public List<StoreVO> selectEStoreList(@Param("query") StoreQuery query);

    /**
     * 新增店铺
     *
     * @param eStore 店铺
     * @return 结果
     */
    public int insertEStore(Store eStore);

    /**
     * 修改店铺
     *
     * @param eStore 店铺
     * @return 结果
     */
    public int updateEStore(@Param("data") Store eStore);

    /**
     * 删除店铺
     *
     * @param storeId 店铺主键
     * @return 结果
     */
    public int deleteEStoreByStoreId(Long storeId);

    /**
     * 批量删除店铺
     *
     * @param storeIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteEStoreByStoreIds(Long[] storeIds);

    /**
     * 根据定位获取城市店铺列表
     */
    List<StoreVO> selectEStoreByCityId(Long cityId);
}
