package com.ruoyi.ss.userWithdraw.mapper;

import com.ruoyi.ss.userWithdraw.domain.UserWithdraw;

import java.util.List;

/**
 * 用户提现渠道Mapper接口
 *
 * @author qzz
 * @date 2024-10-21
 */
public interface UserWithdrawMapper
{
    /**
     * 查询用户提现渠道
     *
     * @param userChannelId 用户提现渠道主键
     * @return 用户提现渠道
     */
    public UserWithdraw selectRlUserWithdrawByUserChannelId(Long userChannelId);

    /**
     * 查询用户提现渠道列表
     *
     * @param rlUserWithdraw 用户提现渠道
     * @return 用户提现渠道集合
     */
    public List<UserWithdraw> selectRlUserWithdrawList(UserWithdraw rlUserWithdraw);

    /**
     * 新增用户提现渠道
     *
     * @param rlUserWithdraw 用户提现渠道
     * @return 结果
     */
    public int insertRlUserWithdraw(UserWithdraw rlUserWithdraw);

    /**
     * 修改用户提现渠道
     *
     * @param rlUserWithdraw 用户提现渠道
     * @return 结果
     */
    public int updateRlUserWithdraw(UserWithdraw rlUserWithdraw);

    /**
     * 删除用户提现渠道
     *
     * @param userChannelId 用户提现渠道主键
     * @return 结果
     */
    public int deleteRlUserWithdrawByUserChannelId(Long userChannelId);

    /**
     * 批量删除用户提现渠道
     *
     * @param userChannelIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteRlUserWithdrawByUserChannelIds(Long[] userChannelIds);

    /**
     * 根据userId查询用户提现渠道列表
     *
     * @param userId 用户id
     * @return 用户提现渠道集合
     */
    List<UserWithdraw> selectRlUserWithdrawListByUserId(Long userId);
}
