package com.ruoyi.ss.withdraw.mapper;

import com.ruoyi.ss.withdraw.domain.Withdraw;
import com.ruoyi.ss.withdraw.domain.WithdrawVO;

import java.math.BigDecimal;
import java.util.List;

/**
 * 提现记录Mapper接口
 *
 * @author qzz
 * @date 2024-09-28
 */
public interface WithdrawMapper
{
    /**
     * 查询提现记录
     *
     * @param id 提现记录主键
     * @return 提现记录
     */
    public WithdrawVO selectRlWithdrawById(Long id);

    /**
     * 查询提现记录列表
     *
     * @param rlWithdraw 提现记录
     * @return 提现记录集合
     */
    public List<Withdraw> selectRlWithdrawList(Withdraw rlWithdraw);

    /**
     * 新增提现记录
     *
     * @param rlWithdraw 提现记录
     * @return 结果
     */
    public int insertRlWithdraw(Withdraw rlWithdraw);

    /**
     * 修改提现记录
     *
     * @param rlWithdraw 提现记录
     * @return 结果
     */
    public int updateRlWithdraw(Withdraw rlWithdraw);

    /**
     * 删除提现记录
     *
     * @param id 提现记录主键
     * @return 结果
     */
    public int deleteRlWithdrawById(Long id);

    /**
     * 批量删除提现记录
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteRlWithdrawByIds(Long[] ids);

    /**
     * 累计提现金额
     *
     * @param RlUserId 用户id
     * @return 结果
     */
    BigDecimal cumulativeWithdrawalAmount(Long RlUserId);
}
